# compatibility with legacy rpm
%{!?_lib:%define _lib	lib}

%define	__s		-s
%define	__soversion	4.0
%define	_libdb_a	libdb-%{__soversion}.a
%define	_libcxx_a	libdb_cxx-%{__soversion}.a

Summary: The Berkeley DB database library for C.
Name: db4
Version: 4.0.14
Release: 0.4
Source: http://www.sleepycat.com/update/%{version}/db-%{version}.tar.gz
Patch0: db-3.0.55-linux.patch
Patch1: db-3.1.17-jbj.patch
URL: http://www.sleepycat.com/
License: BSDish
Group: System Environment/Libraries

%ifos linux
# XXX written as a file prereq in order to build with glibc-2.1.3
BuildPreReq: /usr/lib/libdb1.a
%endif
BuildPreReq: findutils, perl, tcl

BuildRoot: %{_tmppath}/%{name}-root
Prefix: %{_prefix}

%description
The Berkeley Database (Berkeley DB) is a programmatic toolkit that provides
embedded database support for both traditional and client/server applications.
Berkeley DB is used by many applications, including Python and Perl, so this
should be installed on all systems.

%package utils
Summary: Command line tools for managing Berkeley DB databases.
Group: Applications/Databases
Requires: db4 = %{version}
Prefix: %{_prefix}
Obsoletes: db3-utils

%description utils
The Berkeley Database (Berkeley DB) is a programmatic toolkit that provides
embedded database support for both traditional and client/server applications.
Berkeley DB includes B+tree, Extended Linear Hashing, Fixed and Variable-length
record access methods, transactions, locking, logging, shared memory caching
and database recovery. DB supports C, C++, Java and Perl APIs.

This package contains command line tools for managing Berkeley DB databases.

%package devel
Summary: Development libraries/header files for the Berkeley DB library.
Group: System Environment/Libraries
Requires: db4 = %{version}
Prefix: %{_prefix}
Obsoletes: db3-devel

%description devel
The Berkeley Database (Berkeley DB) is a programmatic toolkit that provides
embedded database support for both traditional and client/server applications.
Berkeley DB includes B+tree, Extended Linear Hashing, Fixed and Variable-length
record access methods, transactions, locking, logging, shared memory caching
and database recovery. DB supports C, C++, Java and Perl APIs.

This package contains the header files, libraries, and documentation for
building programs which use Berkeley DB.

%prep
%setup -q -n db-%{version}

# Fix permissions configure
chmod a+x dist/configure

# fixup doc paths
find docs -name "*.html" | xargs perl -p -i -e 's,="images/,="../%{name}-%{version}/images/,g'
find docs -name "*.html" | xargs perl -p -i -e 's,="\.\./images/,="../../%{name}-%{version}/images/,g'
find docs -name "*.html" | xargs perl -p -i -e 's,="\.\./\.\./images/,="../../../%{name}-%{version}/images/,g'

find docs -name "*.html" | xargs perl -p -i -e 's,="api_c/,="../%{name}-devel-%{version}/api_c/,g'
find docs -name "*.html" | xargs perl -p -i -e 's,="\.\./api_c/,="../../%{name}-devel-%{version}/api_c/,g'
find docs -name "*.html" | xargs perl -p -i -e 's,="\.\./\.\./api_c/,="../../../%{name}-devel-%{version}/api_c/,g'

find docs -name "*.html" | xargs perl -p -i -e 's,="api_cxx/,="../%{name}-devel-%{version}/api_cxx/,g'
find docs -name "*.html" | xargs perl -p -i -e 's,="\.\./api_cxx/,="../../%{name}-devel-%{version}/api_cxx/,g'
find docs -name "*.html" | xargs perl -p -i -e 's,="\.\./\.\./api_cxx/,="../../../%{name}-devel-%{version}/api_cxx/,g'

find docs -name "*.html" | xargs perl -p -i -e 's,="api_java/,="../%{name}-devel-%{version}/api_java/,g'
find docs -name "*.html" | xargs perl -p -i -e 's,="\.\./api_java/,="../../%{name}-devel-%{version}/api_java/,g'
find docs -name "*.html" | xargs perl -p -i -e 's,="\.\./\.\./api_java/,="../../../%{name}-devel-%{version}/api_java/,g'

find docs -name "*.html" | xargs perl -p -i -e 's,="api_tcl/,="../%{name}-devel-%{version}/api_tcl/,g'
find docs -name "*.html" | xargs perl -p -i -e 's,="\.\./api_tcl/,="../../%{name}-devel-%{version}/api_tcl/,g'
find docs -name "*.html" | xargs perl -p -i -e 's,="\.\./\.\./api_tcl/,="../../../%{name}-devel-%{version}/api_tcl/,g'

find docs -name "*.html" | xargs perl -p -i -e 's,="examples_c/,="../%{name}-devel-%{version}/examples_c/,g'
find docs -name "*.html" | xargs perl -p -i -e 's,="\.\./examples_c/,="../../%{name}-devel-%{version}/examples_c/,g'
find docs -name "*.html" | xargs perl -p -i -e 's,="\.\./\.\./examples_c/,="../../../%{name}-devel-%{version}/examples_c/,g'

find docs -name "*.html" | xargs perl -p -i -e 's,="examples_cxx/,="../%{name}-devel-%{version}/examples_cxx/,g'
find docs -name "*.html" | xargs perl -p -i -e 's,="\.\./examples_cxx/,="../../%{name}-devel-%{version}/examples_cxx/,g'
find docs -name "*.html" | xargs perl -p -i -e 's,="\.\./\.\./examples_cxx/,="../../../%{name}-devel-%{version}/examples_cxx/,g'

find docs -name "*.html" | xargs perl -p -i -e 's,="ref/,="../%{name}-devel-%{version}/ref/,g'
find docs -name "*.html" | xargs perl -p -i -e 's,="\.\./ref/,="../../%{name}-devel-%{version}/ref/,g'
find docs -name "*.html" | xargs perl -p -i -e 's,="\.\./\.\./ref/,="../../../%{name}-devel-%{version}/ref/,g'

find docs -name "*.html" | xargs perl -p -i -e 's,="sleepycat/,="../%{name}-devel-%{version}/sleepycat/,g'
find docs -name "*.html" | xargs perl -p -i -e 's,="\.\./sleepycat/,="../../%{name}-devel-%{version}/sleepycat/,g'
find docs -name "*.html" | xargs perl -p -i -e 's,="\.\./\.\./sleepycat/,="../../../%{name}-devel-%{version}/sleepycat/,g'

find docs -name "*.html" | xargs perl -p -i -e 's,="utility/,="../%{name}-utils-%{version}/utility/,g'
find docs -name "*.html" | xargs perl -p -i -e 's,="\.\./utility/,="../../%{name}-utils-%{version}/utility/,g'
find docs -name "*.html" | xargs perl -p -i -e 's,="\.\./\.\./utility/,="../../../%{name}-utils-%{version}/utility/,g'

# XXX bogus: avoid pthread_condattr_setpshared() ENOSYS failure.
#%patch0 -p1 -b .linux
# XXX bogus: internal test-and-set asm from linuxthreads.
#%patch1 -p1 -b .jbj
#cd dist
#sh s_config

%build

cd build_unix

# XXX --enable-posixmutexes is useful for threads but useless for interprocess locking.
# XXX --enable-diagnostic should be disabled for production (but is useful).
# XXX --enable-debug_{r,w}op should be disabled for production.
# XXX --enable-java
CFLAGS="$RPM_OPT_FLAGS" ../dist/configure --prefix=%{_prefix} --enable-compat185 --enable-dump185 --enable-shared --enable-static --enable-rpc --enable-cxx

make libdb=%{_libdb_a} %{_libdb_a}
make libcxx=%{_libcxx_a} %{_libcxx_a}

# Static link with old db-185 libraries.
/bin/sh ./libtool --mode=compile cc -c -O2 -g -g -I/usr/include/db1 -I../dist/../include -D_REENTRANT  ../dist/../db_dump185/db_dump185.c
cc %{__s} -static -o db_dump185 db_dump185.lo -L%{_libdir} -ldb1

# Compile rest normally.
make libdb=%{_libdb_a} libcxx=%{_libcxx_a} TCFLAGS='-I$(builddir) -I/usr/include' LDFLAGS="%{__s}"

# remove dangling tags symlink from examples.
rm -f examples_cxx/tags
rm -f examples_c/tags

%install
rm -rf ${RPM_BUILD_ROOT}
mkdir -p ${RPM_BUILD_ROOT}%{_includedir}
mkdir -p ${RPM_BUILD_ROOT}%{_prefix}/lib

cd build_unix

# XXX install_java
#make libdb=%{_libdb_a} libcxx=%{_libcxx_a} LDFLAGS="%{__s}" prefix=${RPM_BUILD_ROOT}%{_prefix} install_include install_shared install_static install_shared_cxx install_static_cxx install_utilities
make libdb=%{_libdb_a} libcxx=%{_libcxx_a} LDFLAGS="%{__s}" prefix=${RPM_BUILD_ROOT}%{_prefix} install_include install_lib install_utilities install_docs

# XXX annoying
set -x
( cd ${RPM_BUILD_ROOT}

%ifos linux
  mkdir -p ./%{_lib}
  mv .%{_prefix}/lib/libdb[-.]*so* ./%{_lib}
  if [ "%{_libdir}" != "%{_prefix}/lib" ]; then
    mkdir -p .%{_libdir}
    mv .%{_prefix}/lib/libdb* .%{_libdir}
  fi
%endif

  mkdir -p .%{_includedir}/db4
  mv .%{_prefix}/include/*.h .%{_includedir}/db4
  ln -sf db4/db.h .%{_includedir}/db.h
# XXX Rather than hack *.la (see below), create /usr/lib/libdb-3.1.so symlink.
  ln -sf ../../lib/libdb-%{__soversion}.so .%{_libdir}/libdb-%{__soversion}.so
# XXX This is needed for packaging db4 for Red Hat 7.x
  for F in .%{_prefix}/bin/db_* ; do
    mv $F `echo $F | sed -e 's,/db_,/db4_,'`
    ln -snf `basename $F | sed -e 's/db_/db4_/'` $F
  done
)
set +x

# XXX libdb-3.1.so is in /lib teach libtool as well
#perl -pi -e 's,/usr,,' ${RPM_BUILD_ROOT}%{_libdir}/libdb-%{__soversion}.la

%clean
rm -rf ${RPM_BUILD_ROOT}

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root)
%doc LICENSE README docs/images
%ifos linux
/%{_lib}/libdb-%{__soversion}.so
%else
%{_libdir}/libdb-%{__soversion}.so
%endif
%{_libdir}/libdb_cxx-%{__soversion}.so

%files utils
%defattr(-,root,root)
%doc	docs/utility
%{_bindir}/berkeley_db_svc
%{_bindir}/db*_archive
%{_bindir}/db*_checkpoint
%{_bindir}/db*_deadlock
%{_bindir}/db*_dump
%{_bindir}/db*_dump185
%{_bindir}/db*_load
%{_bindir}/db*_printlog
%{_bindir}/db*_recover
%{_bindir}/db*_stat
%{_bindir}/db*_upgrade
%{_bindir}/db*_verify

%files devel
%defattr(-,root,root)
%doc	docs/api_c docs/api_cxx docs/api_java docs/index.html
%doc	docs/ref docs/sleepycat
%doc	examples_c examples_cxx
%{_libdir}/libdb-%{__soversion}.la
%{_libdir}/libdb_cxx-%{__soversion}.la
%{_libdir}/%{_libdb_a}
%{_libdir}/%{_libcxx_a}
%{_includedir}/db4/db.h
%{_includedir}/db4/db_185.h
%{_includedir}/db4/db_cxx.h
%{_includedir}/db.h
%ifos linux
/%{_lib}/libdb.so
/%{_libdir}/libdb-%{__soversion}.so
%else
%{_libdir}/libdb.so
%endif
%{_libdir}/libdb_cxx.so

%changelog
* Fri Oct 22 2004 David Summers <david@summersoft.fay.ar.us> 4.0.14-0.4
- Don't keep track of individual db source files, put it all in one tarball.

* Sat Dec 07 2002 Danny Sung <dannys@mail.com>
- Replace db3-utils and db3-devel if they're already installed.

* Wed Nov 20 2002 Danny Sung <dannys@mail.com>
- use db4 instead of db for prefixes, to be compatible with RH7.x db1,
  db2, and db3 package.s

* Sat Aug 03 2002 David Summers <david@summersoft.fay.ar.us> 4.0.14-0.2
- Fixed dist/configure to be executable.

* Tue Jan 15 2002 David Summers <david@summersoft.fay.ar.us> 4.0.14-0.1
- Fixed include path to be /usr/include/db4 instead of /usr/include/db3.

* Wed Jan 02 2002 David Summers <david@summersoft.fay.ar.us> 4.0.14-0
- Updated to db-4.0.14.

* Thu Apr 05 2001 Nalin Dahyabhai <nalin@redhat.com>
- fix URLs in docs for the -utils and -devel subpackages to point to the
  images in the main package's documentation directory (#33328)
- change Copyright: GPL to License: BSDish

* Fri Mar 23 2001 Bill Nottingham <notting@redhat.com>
- turn off --enable-debug

* Tue Dec 12 2000 Jeff Johnson <jbj@redhat.com>
- rebuild to remove 777 directories.

* Sat Nov 11 2000 Jeff Johnson <jbj@redhat.com>
- don't build with --enable-diagnostic.
- add build prereq on tcl.
- default value for %%_lib macro if not found.

* Tue Oct 17 2000 Jeff Johnson <jbj@redhat.com>
- add /usr/lib/libdb-3.1.so symlink to %%files.
- remove dangling tags symlink from examples.

* Mon Oct  9 2000 Jeff Johnson <jbj@redhat.com>
- rather than hack *.la (see below), create /usr/lib/libdb-3.1.so symlink.
- turn off --enable-diagnostic for performance.

* Fri Sep 29 2000 Jeff Johnson <jbj@redhat.com>
- update to 3.1.17.
- disable posix mutexes Yet Again.

* Tue Sep 26 2000 Jeff Johnson <jbj@redhat.com>
- add c++ and posix mutex support.

* Thu Sep 14 2000 Jakub Jelinek <jakub@redhat.com>
- put nss_db into a separate package

* Wed Aug 30 2000 Matt Wilson <msw@redhat.com>
- rebuild to cope with glibc locale binary incompatibility, again

* Wed Aug 23 2000 Jeff Johnson <jbj@redhat.com>
- remove redundant strip of libnss_db* that is nuking symbols.
- change location in /usr/lib/libdb-3.1.la to point to /lib (#16776).

* Thu Aug 17 2000 Jeff Johnson <jbj@redhat.com>
- summaries from specspo.
- all of libdb_tcl* (including symlinks) in db3-utils, should be db3->tcl?

* Wed Aug 16 2000 Jakub Jelinek <jakub@redhat.com>
- temporarily build nss_db in this package, should be moved
  into separate nss_db package soon

* Wed Jul 19 2000 Jakub Jelinek <jakub@redhat.com>
- rebuild to cope with glibc locale binary incompatibility

* Wed Jul 12 2000 Prospector <bugzilla@redhat.com>
- automatic rebuild

* Sun Jun 11 2000 Jeff Johnson <jbj@redhat.com>
- upgrade to 3.1.14.
- create db3-utils sub-package to hide tcl dependency, enable tcl Yet Again.
- FHS packaging.

* Mon Jun  5 2000 Jeff Johnson <jbj@redhat.com>
- disable tcl Yet Again, base packages cannot depend on libtcl.so.

* Sat Jun  3 2000 Jeff Johnson <jbj@redhat.com>
- enable tcl, rebuild against tcltk 8.3.1 (w/o pthreads).

* Tue May 30 2000 Matt Wilson <msw@redhat.com>
- include /lib/libdb.so in the devel package

* Wed May 10 2000 Jeff Johnson <jbj@redhat.com>
- put in "System Environment/Libraries" per msw instructions.

* Tue May  9 2000 Jeff Johnson <jbj@redhat.com>
- install shared library in /lib, not /usr/lib.
- move API docs to db3-devel.

* Mon May  8 2000 Jeff Johnson <jbj@redhat.com>
- don't rename db_* to db3_*.

* Tue May  2 2000 Jeff Johnson <jbj@redhat.com>
- disable --enable-test --enable-debug_rop --enable-debug_wop.
- disable --enable-posixmutexes --enable-tcl as well, to avoid glibc-2.1.3
  problems.

* Mon Apr 24 2000 Jeff Johnson <jbj@redhat.com>
- add 3.0.55.1 alignment patch.
- add --enable-posixmutexes (linux threads has not pthread_*attr_setpshared).
- add --enable-tcl (needed -lpthreads).

* Sat Apr  1 2000 Jeff Johnson <jbj@redhat.com>
- add --enable-debug_{r,w}op for now.
- add variable to set shm perms.

* Sat Mar 25 2000 Jeff Johnson <jbj@redhat.com>
- update to 3.0.55

* Tue Dec 29 1998 Jeff Johnson <jbj@redhat.com>
- Add --enable-cxx to configure.

* Thu Jun 18 1998 Jeff Johnson <jbj@redhat.com>
- Create.
